=== debian/changelog ===
in-toto-golang (0.9.0+ds-5) unstable; urgency=medium

  [ Simon Josefsson ]
  * Modernize Salsa CI
  * Use watch v5
  * Drop Rules-Requires-Root: no
  * Standards-Version: 4.7.3
  * Use dh-sequence-golang
  * Bump debian/* copyright years

  [ Chris Lamb ]
  * Fix reproducibility (Closes: #1121801)

 -- Simon Josefsson <simon@josefsson.org>  Mon, 29 Dec 2025 00:43:30 +0100

in-toto-golang (0.9.0+ds-4) unstable; urgency=medium

  * Add salsa-ci.yml.
  * Standards-Version: 4.7.2.
  * Add Static-Built-Using.

 -- Simon Josefsson <simon@josefsson.org>  Sat, 16 Aug 2025 14:07:46 +0200

in-toto-golang (0.9.0+ds-3) unstable; urgency=medium

  * Fix autopkgtest failures by avoiding alterations to a reference
    tarball for the test suite

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 26 Jun 2024 20:36:39 -0400

in-toto-golang (0.9.0+ds-2) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 16 May 2024 08:14:10 -0400

in-toto-golang (0.9.0+ds-1) experimental; urgency=medium

  * Initial release (Closes: #1060818)

 -- Simon Josefsson <simon@josefsson.org>  Fri, 19 Jan 2024 10:09:34 +0100
