=== debian/control ===
Source: in-toto-golang
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Section: golang
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-google-go-cmp-dev,
 golang-github-secure-systems-lab-go-securesystemslib-dev,
 golang-github-shibumi-go-pathspec-dev,
 golang-github-spf13-cobra-dev,
 golang-github-spiffe-go-spiffe-dev,
 golang-github-stretchr-testify-dev,
 golang-golang-x-sys-dev,
 golang-google-grpc-dev,
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/go-team/packages/in-toto-golang
Vcs-Git: https://salsa.debian.org/go-team/packages/in-toto-golang.git
Homepage: https://github.com/in-toto/in-toto-golang
XS-Go-Import-Path: github.com/in-toto/in-toto-golang

Package: in-toto-golang
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Static-Built-Using:
 ${misc:Static-Built-Using},
Description: software supply chain integrity framework in-toto for Go
 in-toto provides tools both for software developers to authenticate operations
 in the supply chain, as well as for end-users to verify the authentication
 trail when installing a software product.
 .
 This package contains the "in-toto-golang" command-line tool.

Package: golang-github-in-toto-in-toto-golang-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-google-go-cmp-dev,
 golang-github-secure-systems-lab-go-securesystemslib-dev,
 golang-github-shibumi-go-pathspec-dev,
 golang-github-spf13-cobra-dev,
 golang-github-stretchr-testify-dev,
 golang-golang-x-sys-dev,
 golang-google-grpc-dev,
 ${misc:Depends},
Description: software supply chain integrity framework in-toto for Go (library)
 in-toto provides tools both for software developers to authenticate operations
 in the supply chain, as well as for end-users to verify the authentication
 trail when installing a software product.
 .
 This package contains the Go library.
