=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/in-toto/in-toto-golang/releases?per_page=50
Matching-Pattern: https://api.github.com/repos/[^/]+/[^/]+/tarball/v?@ANY_VERSION@
Dversionmangle: auto
Filenamemangle: s%.*/v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%
Repacksuffix: +ds
Searchmode: plain
